
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

    <title>Trial&amp;Error - Prototyping - Continous Integration &#8212; Varnish version 6.0.11 documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/classic.css" />
    
    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Far, far away" href="farfaraway.html" />
    <link rel="prev" title="Something (funny) happened on the way to 5.1.0^H1^H2" href="somethinghappened.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="farfaraway.html" title="Far, far away"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="somethinghappened.html" title="Something (funny) happened on the way to 5.1.0^H1^H2"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">Poul-Hennings random outbursts</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Trial&amp;Error - Prototyping - Continous Integration</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="trial-error-prototyping-continous-integration">
<span id="phk-trialerror"></span><h1>Trial&amp;Error - Prototyping - Continous Integration<a class="headerlink" href="#trial-error-prototyping-continous-integration" title="Permalink to this headline">¶</a></h1>
<p>The other day I chatted to a friend who wrote his phd thesis with
<a class="reference external" href="https://en.wikipedia.org/wiki/David_Wheeler_(British_computer_scientist)">David Wheeler</a> as his advisor, that made me feel young, because Wheeler
was the guy who invented the subroutine.</p>
<p>No, not ‘a subroutine’ but ‘the subroutine’.</p>
<p>In the 1980’ies, right when I had started in IT, there was the new
fashion: “Prototyping”.</p>
<p>It was all over the place, in 1983 Datamation you could about <em>“Data
driven prototyping”</em>, and by 1990 it had bubbled up to management
and Information and Software Technology could publish <em>“Organization
and Management of Systems Prototyping”</em> etc.  etc.</p>
<p>The grey-beard at my workplace laconically said <em>“We already do that,
only we call it Trial&amp;Error.”</em></p>
<p>Programming has always been Trial&amp;Error, and probably always will.</p>
<p>All the early pioneers, like Wheeler, complained about how
batch-scheduling of machine resources removed the “intimate” contact
with the running program and argued that it prolonged the debugging
process.</p>
<p>Practically all the oral histories from back then are about people
sneaking in to university or work at night, to get the computer for
themselves.</p>
<p>But we could call it “Prototyping” if that sounded better, and now
that the history-deficient dot-com generation has “invented” it,
we can call it “Continous Integration”.</p>
<p>I don’t care - it’s still Trial&amp;Error to me.</p>
<p>They guy I chatted with told how after his phd thesis he
<em>“swore to never again attempt to solve a problem with inadequate
tools”</em>.</p>
<p>That is sound advice, and we all tend to forget it all the time,
so reminded, I did a mental inventory on the train home: Which tools
do I use even though I find them inadequate.</p>
<p>And then I decided to do something about them.</p>
<p>First thing was my lab which has - erhh… evolved? - over the last 15 years.</p>
<p>Some of the original assumptions were plain wrong, and a lot of “As
a temporary solution I can …” hacks became permanent, and so on.</p>
<p>I spent two days cleaning, moving, shuffling and generally tidying
my lab, (Amongst other discoveries:  The original two SCSI disks
from the first “freefall.freebsd.org” machine built by Rod Grimes.)
and it is now a lot more pleasant for the work I do these days.</p>
<p>Second thing was the Jenkins and Travis we use for Tria^H^H^H^Continuous
Integration in the Varnish Project.</p>
<p>Jenkins and Travis are both general purpose
program-test-framework-cloud-thingies, and they’re fine up to a
point, but they are inadequate tools for me in too many ways.</p>
<p>Jenkins is written in Java, which is not something I want to inflict
on computers volutarily, in particular not on computers people lend
us to test varnish on.</p>
<p>Travis is Linux only, which is fine if you run Linux only, but I don’t.</p>
<p>But worst of all:  Neither of them fully understand of our varnishtest
tool, and therefore their failure reports are tedious and cumbersome
to use.</p>
<p>So, taking my friends advice, I sat down and wrote VTEST, which
consists of two small pieces of code: Tester and Reporter.</p>
<p>The tester is a small, 173 lines, <a class="reference external" href="https://github.com/varnishcache/varnish-cache/blob/master/tools/vtest.sh">portable and simple shell script</a>
which runs on the computer, physical or virtual, where we want
to test Varnish.</p>
<p>It obviously needs the compilers and tools we require to compile
Varnish, (autocrap, sphinx, graphviz) but it doesn’t anything
beyond that, in particular it does not need a java runtime, a
GUI or a hole in your firewall.</p>
<p>The tester sends a report to the project server with ssh(1), and
the reporter, which is just 750 lines of python code, ingests and
digests the report and spits out some <a class="reference external" href="http://varnish-cache.org/vtest/">pidgin HTML</a> with the information I actually
want to see.</p>
<p>And just like with the varnishtest program before it, once I
had done it, my first thought was <em>“Why didn’t I do that long time ago?”</em></p>
<p>So it is only fair to dedicate VTEST to the friend I chatted with:</p>
<img alt="../_images/bjarne.jpeg" src="../_images/bjarne.jpeg" />
<p><a class="reference external" href="http://www.stroustrup.com/">Bjarne</a> tried to model how to best
distribute operating system kernels across a network, wrote a
adequate programming language tool for the job, which was also
an adequate tool for a lot of other programming jobs.</p>
<p>Thanks Bjarne!</p>
<p>Poul-Henning, 2016-11-21</p>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="somethinghappened.html"
                        title="previous chapter">Something (funny) happened on the way to 5.1.0^H1^H2</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="farfaraway.html"
                        title="next chapter">Far, far away</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/phk/trialerror.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="farfaraway.html" title="Far, far away"
             >next</a> |</li>
        <li class="right" >
          <a href="somethinghappened.html" title="Something (funny) happened on the way to 5.1.0^H1^H2"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >Poul-Hennings random outbursts</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Trial&amp;Error - Prototyping - Continous Integration</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010-2014, Varnish Software AS.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 4.3.2.
    </div>
  </body>
</html>